Package javax.mail.internet

# Class MimeMessage

java.lang.Object
javax.mail.Message
javax.mail.internet.MimeMessage

All Implemented Interfaces:
  `MimePart`, `Part`

Direct Known Subclasses:
  `IMAPMessage`, `MessageHeaders`, `POP3Message`, `SMTPMessage`

public class MimeMessage extends Message implements MimePart
This class represents a MIME style email message. It implements the `Message` abstract class and the `MimePart` interface.

Clients wanting to create new MIME style messages will instantiate an empty MimeMessage object and then fill it with appropriate attributes and content.

Service providers that implement MIME compliant backend stores may want to subclass MimeMessage and override certain methods to provide specific implementations. The simplest case is probably a provider that generates a MIME style input stream and leaves the parsing of the stream to this class.

MimeMessage uses the `InternetHeaders` class to parse and store the top level RFC 822 headers of a message.

The `mail.mime.address.strict` session property controls the parsing of address headers. By default, strict parsing of address headers is done. If this property is set to `"false"`, strict parsing is not done and many illegal addresses that sometimes occur in real messages are allowed. See the `InternetAddress` class for details.

A note on RFC 822 and MIME headers

RFC 822 header fields must contain only US-ASCII characters. MIME allows non ASCII characters to be present in certain portions of certain headers, by encoding those characters. RFC 2047 specifies the rules for doing this. The MimeUtility class provided in this package can be used to to achieve this. Callers of the `setHeader`, `addHeader`, and `addHeaderLine` methods are responsible for enforcing the MIME requirements for the specified headers. In addition, these header fields must be folded (wrapped) before being sent if they exceed the line length limitation for the transport (1000 bytes for SMTP). Received headers may have been folded. The application is responsible for folding and unfolding headers as appropriate.

Author:
  John Mani, Bill Shannon, Max Spivak, Kanwar Oberoi
See Also:
  - `MimeUtility`
  - `Part`
  - `Message`
  - `MimePart`
  - `InternetAddress`

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`MimeMessage.RecipientType`
This inner class extends the javax.mail.Message.RecipientType class to add additional RecipientTypes.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Object`
`cachedContent`
If our content is a Multipart or Message object, we save it the first time it's created by parsing a stream so that changes to the contained objects will not be lost.
`protected byte[]`
`content`
Byte array that holds the bytes of this Message's content.
`protected InputStream`
`contentStream`
If the data for this message was supplied by an InputStream that implements the SharedInputStream interface, `contentStream` is another such stream representing the content of this message.
`protected DataHandler`
`dh`
The DataHandler object representing this Message's content.
`protected Flags`
`flags`
The Flags for this message.
`protected InternetHeaders`
`headers`
The InternetHeaders object that stores the header of this message.
`protected boolean`
`modified`
A flag indicating whether the message has been modified.
`protected boolean`
`saved`
Does the `saveChanges` method need to be called on this message? This flag is set to false by the public constructor and set to true by the `saveChanges` method.

### Fields inherited from class javax.mail.Message

`expunged, folder, msgnum, session`

### Fields inherited from interface javax.mail.Part

`ATTACHMENT, INLINE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`MimeMessage(Folder folder, int msgnum)`
Constructs an empty MimeMessage object with the given Folder and message number.
`protected`
`MimeMessage(Folder folder, InputStream is, int msgnum)`
Constructs a MimeMessage by reading and parsing the data from the specified MIME InputStream.
`protected`
`MimeMessage(Folder folder, InternetHeaders headers, byte[] content, int msgnum)`
Constructs a MimeMessage from the given InternetHeaders object and content.
``
`MimeMessage(MimeMessage source)`
Constructs a new MimeMessage with content initialized from the `source` MimeMessage.
``
`MimeMessage(Session session)`
Default constructor.
``
`MimeMessage(Session session, InputStream is)`
Constructs a MimeMessage by reading and parsing the data from the specified MIME InputStream.

## Method Summary

Modifier and Type
Method
Description
`void`
`addFrom(Address[] addresses)`
Add the specified addresses to the existing "From" field.
`void`
`addHeader(String name, String value)`
Add this value to the existing values for this header_name.
`void`
`addHeaderLine(String line)`
Add a raw RFC 822 header-line.
`void`
`addRecipients(Message.RecipientType type, String addresses)`
Add the given addresses to the specified recipient type.
`void`
`addRecipients(Message.RecipientType type, Address[] addresses)`
Add the given addresses to the specified recipient type.
`protected InternetHeaders`
`createInternetHeaders(InputStream is)`
Create and return an InternetHeaders object that loads the headers from the given InputStream.
`protected MimeMessage`
`createMimeMessage(Session session)`
Create and return a MimeMessage object.
`Enumeration<String>`
`getAllHeaderLines()`
Get all header lines as an Enumeration of Strings.
`Enumeration<Header>`
`getAllHeaders()`
Return all the headers from this Message as an enumeration of Header objects.
`Address[]`
`getAllRecipients()`
Get all the recipient addresses for the message.
`Object`
`getContent()`
Return the content as a Java object.
`String`
`getContentID()`
Returns the value of the "Content-ID" header field.
`String[]`
`getContentLanguage()`
Get the languages specified in the "Content-Language" header field of this message.
`String`
`getContentMD5()`
Return the value of the "Content-MD5" header field.
`protected InputStream`
`getContentStream()`
Produce the raw bytes of the content.
`String`
`getContentType()`
Returns the value of the RFC 822 "Content-Type" header field.
`DataHandler`
`getDataHandler()`
Return a DataHandler for this Message's content.
`String`
`getDescription()`
Returns the "Content-Description" header field of this Message.
`String`
`getDisposition()`
Returns the disposition from the "Content-Disposition" header field.
`String`
`getEncoding()`
Returns the content transfer encoding from the "Content-Transfer-Encoding" header field.
`String`
`getFileName()`
Get the filename associated with this Message.
`Flags`
`getFlags()`
Return a `Flags` object containing the flags for this message.
`Address[]`
`getFrom()`
Returns the value of the RFC 822 "From" header fields.
`String[]`
`getHeader(String name)`
Get all the headers for this header_name.
`String`
`getHeader(String name, String delimiter)`
Get all the headers for this header name, returned as a single String, with headers separated by the delimiter.
`InputStream`
`getInputStream()`
Return a decoded input stream for this Message's "content".
`int`
`getLineCount()`
Return the number of lines for the content of this message.
`Enumeration<String>`
`getMatchingHeaderLines(String[] names)`
Get matching header lines as an Enumeration of Strings.
`Enumeration<Header>`
`getMatchingHeaders(String[] names)`
Return matching headers from this Message as an Enumeration of Header objects.
`String`
`getMessageID()`
Returns the value of the "Message-ID" header field.
`Enumeration<String>`
`getNonMatchingHeaderLines(String[] names)`
Get non-matching header lines as an Enumeration of Strings.
`Enumeration<Header>`
`getNonMatchingHeaders(String[] names)`
Return non-matching headers from this Message as an Enumeration of Header objects.
`InputStream`
`getRawInputStream()`
Return an InputStream to the raw data with any Content-Transfer-Encoding intact.
`Date`
`getReceivedDate()`
Returns the Date on this message was received.
`Address[]`
`getRecipients(Message.RecipientType type)`
Returns the recepients specified by the type.
`Address[]`
`getReplyTo()`
Return the value of the RFC 822 "Reply-To" header field.
`Address`
`getSender()`
Returns the value of the RFC 822 "Sender" header field.
`Date`
`getSentDate()`
Returns the value of the RFC 822 "Date" field.
`int`
`getSize()`
Return the size of the content of this message in bytes.
`String`
`getSubject()`
Returns the value of the "Subject" header field.
`boolean`
`isMimeType(String mimeType)`
Is this Part of the specified MIME type? This method compares only the `primaryType` and `subType`.
`boolean`
`isSet(Flags.Flag flag)`
Check whether the flag specified in the `flag` argument is set in this message.
`protected void`
`parse(InputStream is)`
Parse the InputStream setting the `headers` and `content` fields appropriately.
`void`
`removeHeader(String name)`
Remove all headers with this name.
`Message`
`reply(boolean replyToAll)`
Get a new Message suitable for a reply to this message.
`Message`
`reply(boolean replyToAll, boolean setAnswered)`
Get a new Message suitable for a reply to this message.
`void`
`saveChanges()`
Updates the appropriate header fields of this message to be consistent with the message's contents.
`void`
`setContent(Object o, String type)`
A convenience method for setting this Message's content.
`void`
`setContent(Multipart mp)`
This method sets the Message's content to a Multipart object.
`void`
`setContentID(String cid)`
Set the "Content-ID" header field of this Message.
`void`
`setContentLanguage(String[] languages)`
Set the "Content-Language" header of this MimePart.
`void`
`setContentMD5(String md5)`
Set the "Content-MD5" header field of this Message.
`void`
`setDataHandler(DataHandler dh)`
This method provides the mechanism to set this part's content.
`void`
`setDescription(String description)`
Set the "Content-Description" header field for this Message.
`void`
`setDescription(String description, String charset)`
Set the "Content-Description" header field for this Message.
`void`
`setDisposition(String disposition)`
Set the disposition in the "Content-Disposition" header field of this body part.
`void`
`setFileName(String filename)`
Set the filename associated with this part, if possible.
`void`
`setFlags(Flags flag, boolean set)`
Set the flags for this message.
`void`
`setFrom()`
Set the RFC 822 "From" header field using the value of the `InternetAddress.getLocalAddress` method.
`void`
`setFrom(String address)`
Set the RFC 822 "From" header field.
`void`
`setFrom(Address address)`
Set the RFC 822 "From" header field.
`void`
`setHeader(String name, String value)`
Set the value for this header_name.
`void`
`setRecipients(Message.RecipientType type, String addresses)`
Set the specified recipient type to the given addresses.
`void`
`setRecipients(Message.RecipientType type, Address[] addresses)`
Set the specified recipient type to the given addresses.
`void`
`setReplyTo(Address[] addresses)`
Set the RFC 822 "Reply-To" header field.
`void`
`setSender(Address address)`
Set the RFC 822 "Sender" header field.
`void`
`setSentDate(Date d)`
Set the RFC 822 "Date" header field.
`void`
`setSubject(String subject)`
Set the "Subject" header field.
`void`
`setSubject(String subject, String charset)`
Set the "Subject" header field.
`void`
`setText(String text)`
Convenience method that sets the given String as this part's content, with a MIME type of "text/plain".
`void`
`setText(String text, String charset)`
Convenience method that sets the given String as this part's content, with a MIME type of "text/plain" and the specified charset.
`void`
`setText(String text, String charset, String subtype)`
Convenience method that sets the given String as this part's content, with a primary MIME type of "text" and the specified MIME subtype.
`protected void`
`updateHeaders()`
Called by the `saveChanges` method to actually update the MIME headers.
`protected void`
`updateMessageID()`
Update the Message-ID header.
`void`
`writeTo(OutputStream os)`
Output the message as an RFC 822 format stream.
`void`
`writeTo(OutputStream os, String[] ignoreList)`
Output the message as an RFC 822 format stream, without specified headers.

### Methods inherited from class javax.mail.Message

`addRecipient, getFolder, getMessageNumber, getSession, isExpunged, match, setExpunged, setFlag, setMessageNumber, setRecipient`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### dh

protected DataHandler dh
The DataHandler object representing this Message's content.

### content

protected byte[] content
Byte array that holds the bytes of this Message's content.

### contentStream

protected InputStream contentStream
If the data for this message was supplied by an InputStream that implements the SharedInputStream interface, `contentStream` is another such stream representing the content of this message. In this case, `content` will be null.

Since:
  JavaMail 1.2

### headers

protected InternetHeaders headers
The InternetHeaders object that stores the header of this message.

### flags

protected Flags flags
The Flags for this message.

### modified

protected boolean modified
A flag indicating whether the message has been modified. If the message has not been modified, any data in the `content` array is assumed to be valid and is used directly in the `writeTo` method. This flag is set to true when an empty message is created or when the `saveChanges` method is called.

Since:
  JavaMail 1.2

### saved

protected boolean saved
Does the `saveChanges` method need to be called on this message? This flag is set to false by the public constructor and set to true by the `saveChanges` method. The `writeTo` method checks this flag and calls the `saveChanges` method as necessary. This avoids the common mistake of forgetting to call the `saveChanges` method on a newly constructed message.

Since:
  JavaMail 1.2

### cachedContent

protected Object cachedContent
If our content is a Multipart or Message object, we save it the first time it's created by parsing a stream so that changes to the contained objects will not be lost.

If this field is not null, it's return by the `getContent()` method. The `getContent()` method sets this field if it would return a Multipart or MimeMessage object. This field is is cleared by the `setDataHandler(javax.activation.DataHandler)` method.

Since:
  JavaMail 1.5

## Constructor Details

### MimeMessage

public MimeMessage(Session session)
Default constructor. An empty message object is created. The `headers` field is set to an empty InternetHeaders object. The `flags` field is set to an empty Flags object. The `modified` flag is set to true.

Parameters:
  `session` - the Sesssion

### MimeMessage

public MimeMessage(Session session, InputStream is) throws MessagingException
Constructs a MimeMessage by reading and parsing the data from the specified MIME InputStream. The InputStream will be left positioned at the end of the data for the message. Note that the input stream parse is done within this constructor itself.

The input stream contains an entire MIME formatted message with headers and data.

Parameters:
  `session` - Session object for this message
  `is` - the message input stream
Throws:
  `MessagingException` - for failures

### MimeMessage

public MimeMessage(MimeMessage source) throws MessagingException
Constructs a new MimeMessage with content initialized from the `source` MimeMessage. The new message is independent of the original.

Note: The current implementation is rather inefficient, copying the data more times than strictly necessary.

Parameters:
  `source` - the message to copy content from
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.2

### MimeMessage

protected MimeMessage(Folder folder, int msgnum)
Constructs an empty MimeMessage object with the given Folder and message number.

This method is for providers subclassing `MimeMessage`.

Parameters:
  `folder` - the Folder this message is from
  `msgnum` - the number of this message

### MimeMessage

protected MimeMessage(Folder folder, InputStream is, int msgnum) throws MessagingException
Constructs a MimeMessage by reading and parsing the data from the specified MIME InputStream. The InputStream will be left positioned at the end of the data for the message. Note that the input stream parse is done within this constructor itself.

This method is for providers subclassing `MimeMessage`.

Parameters:
  `folder` - The containing folder.
  `is` - the message input stream
  `msgnum` - Message number of this message within its folder
Throws:
  `MessagingException` - for failures

### MimeMessage

protected MimeMessage(Folder folder, InternetHeaders headers, byte[] content, int msgnum) throws MessagingException
Constructs a MimeMessage from the given InternetHeaders object and content. This method is for providers subclassing `MimeMessage`.

Parameters:
  `folder` - The containing folder.
  `headers` - The headers
  `content` - The message content
  `msgnum` - Message number of this message within its folder
Throws:
  `MessagingException` - for failures

## Method Details

### parse

protected void parse(InputStream is) throws MessagingException
Parse the InputStream setting the `headers` and `content` fields appropriately. Also resets the `modified` flag.

This method is intended for use by subclasses that need to control when the InputStream is parsed.

Parameters:
  `is` - The message input stream
Throws:
  `MessagingException` - for failures

### getFrom

public Address[] getFrom() throws MessagingException
Returns the value of the RFC 822 "From" header fields. If this header field is absent, the "Sender" header field is used. If the "Sender" header field is also absent, `null` is returned.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getFrom` in class `Message`
Returns:
  Address object
Throws:
  `MessagingException` - for failures
See Also:
  - `headers`

### setFrom

public void setFrom(Address address) throws MessagingException
Set the RFC 822 "From" header field. Any existing values are replaced with the given address. If address is `null`, this header is removed.

Specified by:
  `setFrom` in class `Message`
Parameters:
  `address` - the sender of this message
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### setFrom

public void setFrom(String address) throws MessagingException
Set the RFC 822 "From" header field. Any existing values are replaced with the given addresses. If address is `null`, this header is removed.

Parameters:
  `address` - the sender(s) of this message
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
Since:
  JvaMail 1.5

### setFrom

public void setFrom() throws MessagingException
Set the RFC 822 "From" header field using the value of the `InternetAddress.getLocalAddress` method.

Specified by:
  `setFrom` in class `Message`
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### addFrom

public void addFrom(Address[] addresses) throws MessagingException
Add the specified addresses to the existing "From" field. If the "From" field does not already exist, it is created.

Specified by:
  `addFrom` in class `Message`
Parameters:
  `addresses` - the senders of this message
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getSender

public Address getSender() throws MessagingException
Returns the value of the RFC 822 "Sender" header field. If the "Sender" header field is absent, `null` is returned.

This implementation uses the `getHeader` method to obtain the requisite header field.

Returns:
  Address object
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.3
See Also:
  - `headers`

### setSender

public void setSender(Address address) throws MessagingException
Set the RFC 822 "Sender" header field. Any existing values are replaced with the given address. If address is `null`, this header is removed.

Parameters:
  `address` - the sender of this message
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
Since:
  JavaMail 1.3

### getRecipients

public Address[] getRecipients(Message.RecipientType type) throws MessagingException
Returns the recepients specified by the type. The mapping between the type and the corresponding RFC 822 header is as follows:

                    Message.RecipientType.TO                "To"
                    Message.RecipientType.CC                "Cc"
                    Message.RecipientType.BCC               "Bcc"
                    MimeMessage.RecipientType.NEWSGROUPS    "Newsgroups"

Returns null if the header specified by the type is not found or if its value is empty.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getRecipients` in class `Message`
Parameters:
  `type` - Type of recepient
Returns:
  array of Address objects
Throws:
  `MessagingException` - if header could not be retrieved
  `AddressException` - if the header is misformatted
See Also:
  - `headers`
  - `Message.RecipientType.TO`
  - `Message.RecipientType.CC`
  - `Message.RecipientType.BCC`
  - `MimeMessage.RecipientType.NEWSGROUPS`

### getAllRecipients

public Address[] getAllRecipients() throws MessagingException
Get all the recipient addresses for the message. Extracts the TO, CC, BCC, and NEWSGROUPS recipients.

Overrides:
  `getAllRecipients` in class `Message`
Returns:
  array of Address objects
Throws:
  `MessagingException` - for failures
See Also:
  - `Message.RecipientType.TO`
  - `Message.RecipientType.CC`
  - `Message.RecipientType.BCC`
  - `MimeMessage.RecipientType.NEWSGROUPS`

### setRecipients

public void setRecipients(Message.RecipientType type, Address[] addresses) throws MessagingException
Set the specified recipient type to the given addresses. If the address parameter is `null`, the corresponding recipient field is removed.

Specified by:
  `setRecipients` in class `Message`
Parameters:
  `type` - Recipient type
  `addresses` - Addresses
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
See Also:
  - `getRecipients(javax.mail.Message.RecipientType)`

### setRecipients

public void setRecipients(Message.RecipientType type, String addresses) throws MessagingException
Set the specified recipient type to the given addresses. If the address parameter is `null`, the corresponding recipient field is removed.

Parameters:
  `type` - Recipient type
  `addresses` - Addresses
Throws:
  `AddressException` - if the attempt to parse the addresses String fails
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
Since:
  JavaMail 1.2
See Also:
  - `getRecipients(javax.mail.Message.RecipientType)`

### addRecipients

public void addRecipients(Message.RecipientType type, Address[] addresses) throws MessagingException
Add the given addresses to the specified recipient type.

Specified by:
  `addRecipients` in class `Message`
Parameters:
  `type` - Recipient type
  `addresses` - Addresses
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### addRecipients

public void addRecipients(Message.RecipientType type, String addresses) throws MessagingException
Add the given addresses to the specified recipient type.

Parameters:
  `type` - Recipient type
  `addresses` - Addresses
Throws:
  `AddressException` - if the attempt to parse the addresses String fails
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
Since:
  JavaMail 1.2

### getReplyTo

public Address[] getReplyTo() throws MessagingException
Return the value of the RFC 822 "Reply-To" header field. If this header is unavailable or its value is absent, then the `getFrom` method is called and its value is returned. This implementation uses the `getHeader` method to obtain the requisite header field.

Overrides:
  `getReplyTo` in class `Message`
Returns:
  addresses to which replies should be directed
Throws:
  `MessagingException` - for failures
See Also:
  - `headers`

### setReplyTo

public void setReplyTo(Address[] addresses) throws MessagingException
Set the RFC 822 "Reply-To" header field. If the address parameter is `null`, this header is removed.

Overrides:
  `setReplyTo` in class `Message`
Parameters:
  `addresses` - addresses to which replies should be directed
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getSubject

public String getSubject() throws MessagingException
Returns the value of the "Subject" header field. Returns null if the subject field is unavailable or its value is absent.

If the subject is encoded as per RFC 2047, it is decoded and converted into Unicode. If the decoding or conversion fails, the raw data is returned as is.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getSubject` in class `Message`
Returns:
  Subject
Throws:
  `MessagingException` - for failures
See Also:
  - `headers`

### setSubject

public void setSubject(String subject) throws MessagingException
Set the "Subject" header field. If the subject contains non US-ASCII characters, it will be encoded using the platform's default charset. If the subject contains only US-ASCII characters, no encoding is done and it is used as-is. If the subject is null, the existing "Subject" field is removed.

The application must ensure that the subject does not contain any line breaks.

Note that if the charset encoding process fails, a MessagingException is thrown, and an UnsupportedEncodingException is included in the chain of nested exceptions within the MessagingException.

Specified by:
  `setSubject` in class `Message`
Parameters:
  `subject` - The subject
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### setSubject

public void setSubject(String subject, String charset) throws MessagingException
Set the "Subject" header field. If the subject contains non US-ASCII characters, it will be encoded using the specified charset. If the subject contains only US-ASCII characters, no encoding is done and it is used as-is. If the subject is null, the existing "Subject" header field is removed.

The application must ensure that the subject does not contain any line breaks.

Note that if the charset encoding process fails, a MessagingException is thrown, and an UnsupportedEncodingException is included in the chain of nested exceptions within the MessagingException.

Parameters:
  `subject` - The subject
  `charset` - The charset
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getSentDate

public Date getSentDate() throws MessagingException
Returns the value of the RFC 822 "Date" field. This is the date on which this message was sent. Returns null if this field is unavailable or its value is absent.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getSentDate` in class `Message`
Returns:
  The sent Date
Throws:
  `MessagingException` - for failures

### setSentDate

public void setSentDate(Date d) throws MessagingException
Set the RFC 822 "Date" header field. This is the date on which the creator of the message indicates that the message is complete and ready for delivery. If the date parameter is `null`, the existing "Date" field is removed.

Specified by:
  `setSentDate` in class `Message`
Parameters:
  `d` - the sent date of this message
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getReceivedDate

public Date getReceivedDate() throws MessagingException
Returns the Date on this message was received. Returns `null` if this date cannot be obtained.

Note that RFC 822 does not define a field for the received date. Hence only implementations that can provide this date need return a valid value.

This implementation returns `null`.

Specified by:
  `getReceivedDate` in class `Message`
Returns:
  the date this message was received
Throws:
  `MessagingException` - for failures

### getSize

public int getSize() throws MessagingException
Return the size of the content of this message in bytes. Return -1 if the size cannot be determined.

Note that this number may not be an exact measure of the content size and may or may not account for any transfer encoding of the content.

This implementation returns the size of the `content` array (if not null), or, if `contentStream` is not null, and the `available` method returns a positive number, it returns that number as the size. Otherwise, it returns -1.

Specified by:
  `getSize` in interface `Part`
Returns:
  size of content in bytes
Throws:
  `MessagingException` - for failures

### getLineCount

public int getLineCount() throws MessagingException
Return the number of lines for the content of this message. Return -1 if this number cannot be determined.

Note that this number may not be an exact measure of the content length and may or may not account for any transfer encoding of the content.

This implementation returns -1.

Specified by:
  `getLineCount` in interface `Part`
Returns:
  number of lines in the content.
Throws:
  `MessagingException` - for failures

### getContentType

public String getContentType() throws MessagingException
Returns the value of the RFC 822 "Content-Type" header field. This represents the content-type of the content of this message. This value must not be null. If this field is unavailable, "text/plain" should be returned.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getContentType` in interface `Part`
Returns:
  The ContentType of this part
Throws:
  `MessagingException` - for failures
See Also:
  - `DataHandler`

### isMimeType

public boolean isMimeType(String mimeType) throws MessagingException
Is this Part of the specified MIME type? This method compares only the `primaryType` and `subType`. The parameters of the content types are ignored.

For example, this method will return `true` when comparing a Part of content type "text/plain" with "text/plain; charset=foobar".

If the `subType` of `mimeType` is the special character '*', then the subtype is ignored during the comparison.

Specified by:
  `isMimeType` in interface `Part`
Parameters:
  `mimeType` - the MIME type to check
Returns:
  true if it matches the MIME type
Throws:
  `MessagingException` - for failures

### getDisposition

public String getDisposition() throws MessagingException
Returns the disposition from the "Content-Disposition" header field. This represents the disposition of this part. The disposition describes how the part should be presented to the user.

If the Content-Disposition field is unavailable, `null` is returned.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getDisposition` in interface `Part`
Returns:
  disposition of this part, or null if unknown
Throws:
  `MessagingException` - for failures
See Also:
  - `Part.ATTACHMENT`
  - `Part.INLINE`
  - `Part.getFileName()`

### setDisposition

public void setDisposition(String disposition) throws MessagingException
Set the disposition in the "Content-Disposition" header field of this body part. If the disposition is null, any existing "Content-Disposition" header field is removed.

Specified by:
  `setDisposition` in interface `Part`
Parameters:
  `disposition` - disposition of this part
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
See Also:
  - `Part.ATTACHMENT`
  - `Part.INLINE`
  - `Part.setFileName(java.lang.String)`

### getEncoding

public String getEncoding() throws MessagingException
Returns the content transfer encoding from the "Content-Transfer-Encoding" header field. Returns `null` if the header is unavailable or its value is absent.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getEncoding` in interface `MimePart`
Returns:
  content-transfer-encoding
Throws:
  `MessagingException` - for failures

### getContentID

public String getContentID() throws MessagingException
Returns the value of the "Content-ID" header field. Returns `null` if the field is unavailable or its value is absent.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getContentID` in interface `MimePart`
Returns:
  content-ID
Throws:
  `MessagingException` - for failures

### setContentID

public void setContentID(String cid) throws MessagingException
Set the "Content-ID" header field of this Message. If the `cid` parameter is null, any existing "Content-ID" is removed.

Parameters:
  `cid` - the content ID
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getContentMD5

public String getContentMD5() throws MessagingException
Return the value of the "Content-MD5" header field. Returns `null` if this field is unavailable or its value is absent.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getContentMD5` in interface `MimePart`
Returns:
  content-MD5
Throws:
  `MessagingException` - for failures

### setContentMD5

public void setContentMD5(String md5) throws MessagingException
Set the "Content-MD5" header field of this Message.

Specified by:
  `setContentMD5` in interface `MimePart`
Parameters:
  `md5` - the MD5 value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getDescription

public String getDescription() throws MessagingException
Returns the "Content-Description" header field of this Message. This typically associates some descriptive information with this part. Returns null if this field is unavailable or its value is absent.

If the Content-Description field is encoded as per RFC 2047, it is decoded and converted into Unicode. If the decoding or conversion fails, the raw data is returned as-is

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getDescription` in interface `Part`
Returns:
  content-description
Throws:
  `MessagingException` - for failures

### setDescription

public void setDescription(String description) throws MessagingException
Set the "Content-Description" header field for this Message. If the description parameter is `null`, then any existing "Content-Description" fields are removed.

If the description contains non US-ASCII characters, it will be encoded using the platform's default charset. If the description contains only US-ASCII characters, no encoding is done and it is used as-is.

Note that if the charset encoding process fails, a MessagingException is thrown, and an UnsupportedEncodingException is included in the chain of nested exceptions within the MessagingException.

Specified by:
  `setDescription` in interface `Part`
Parameters:
  `description` - content-description
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - An UnsupportedEncodingException may be included in the exception chain if the charset conversion fails.

### setDescription

public void setDescription(String description, String charset) throws MessagingException
Set the "Content-Description" header field for this Message. If the description parameter is `null`, then any existing "Content-Description" fields are removed.

If the description contains non US-ASCII characters, it will be encoded using the specified charset. If the description contains only US-ASCII characters, no encoding is done and it is used as-is.

Note that if the charset encoding process fails, a MessagingException is thrown, and an UnsupportedEncodingException is included in the chain of nested exceptions within the MessagingException.

Parameters:
  `description` - Description
  `charset` - Charset for encoding
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - An UnsupportedEncodingException may be included in the exception chain if the charset conversion fails.

### getContentLanguage

public String[] getContentLanguage() throws MessagingException
Get the languages specified in the "Content-Language" header field of this message. The Content-Language header is defined by RFC 1766. Returns `null` if this field is unavailable or its value is absent.

This implementation uses the `getHeader` method to obtain the requisite header field.

Specified by:
  `getContentLanguage` in interface `MimePart`
Returns:
  value of content-language header.
Throws:
  `MessagingException` - for failures

### setContentLanguage

public void setContentLanguage(String[] languages) throws MessagingException
Set the "Content-Language" header of this MimePart. The Content-Language header is defined by RFC 1766.

Specified by:
  `setContentLanguage` in interface `MimePart`
Parameters:
  `languages` - array of language tags
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getMessageID

public String getMessageID() throws MessagingException
Returns the value of the "Message-ID" header field. Returns null if this field is unavailable or its value is absent.

The default implementation provided here uses the `getHeader` method to return the value of the "Message-ID" field.

Returns:
  Message-ID
Throws:
  `MessagingException` - if the retrieval of this field causes any exception.
Since:
  JavaMail 1.1
See Also:
  - `MessageIDTerm`

### getFileName

public String getFileName() throws MessagingException
Get the filename associated with this Message.

Returns the value of the "filename" parameter from the "Content-Disposition" header field of this message. If it's not available, returns the value of the "name" parameter from the "Content-Type" header field of this BodyPart. Returns `null` if both are absent.

If the `mail.mime.encodefilename` System property is set to true, the `MimeUtility.decodeText` method will be used to decode the filename. While such encoding is not supported by the MIME spec, many mailers use this technique to support non-ASCII characters in filenames. The default value of this property is false.

Specified by:
  `getFileName` in interface `Part`
Returns:
  filename
Throws:
  `MessagingException` - for failures

### setFileName

public void setFileName(String filename) throws MessagingException
Set the filename associated with this part, if possible.

Sets the "filename" parameter of the "Content-Disposition" header field of this message.

If the `mail.mime.encodefilename` System property is set to true, the `MimeUtility.encodeText` method will be used to encode the filename. While such encoding is not supported by the MIME spec, many mailers use this technique to support non-ASCII characters in filenames. The default value of this property is false.

Specified by:
  `setFileName` in interface `Part`
Parameters:
  `filename` - Filename to associate with this part
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getInputStream

public InputStream getInputStream() throws IOException, MessagingException
Return a decoded input stream for this Message's "content".

This implementation obtains the input stream from the DataHandler, that is, it invokes `getDataHandler().getInputStream()`.

Specified by:
  `getInputStream` in interface `Part`
Returns:
  an InputStream
Throws:
  `IOException` - this is typically thrown by the DataHandler. Refer to the documentation for javax.activation.DataHandler for more details.
  `MessagingException` - for other failures
See Also:
  - `getContentStream()`
  - `DataHandler.getInputStream()`

### getContentStream

protected InputStream getContentStream() throws MessagingException
Produce the raw bytes of the content. This method is used during parsing, to create a DataHandler object for the content. Subclasses that can provide a separate input stream for just the message content might want to override this method.

This implementation returns a SharedInputStream, if `contentStream` is not null. Otherwise, it returns a ByteArrayInputStream constructed out of the `content` byte array.

Returns:
  an InputStream containing the raw bytes
Throws:
  `MessagingException` - for failures
See Also:
  - `content`

### getRawInputStream

public InputStream getRawInputStream() throws MessagingException
Return an InputStream to the raw data with any Content-Transfer-Encoding intact. This method is useful if the "Content-Transfer-Encoding" header is incorrect or corrupt, which would prevent the `getInputStream` method or `getContent` method from returning the correct data. In such a case the application may use this method and attempt to decode the raw data itself.

This implementation simply calls the `getContentStream` method.

Returns:
  an InputStream containing the raw bytes
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.2
See Also:
  - `getInputStream()`
  - `getContentStream()`

### getDataHandler

public DataHandler getDataHandler() throws MessagingException
Return a DataHandler for this Message's content.

The implementation provided here works approximately as follows. Note the use of the `getContentStream` method to generate the byte stream for the content. Also note that any transfer-decoding is done automatically within this method.

>       getDataHandler() {
>           if (dh == null) {
>               dh = new DataHandler(new MimePartDataSource(this));
>           }
>           return dh;
>       }

>       class MimePartDataSource implements DataSource {
>           public getInputStream() {
>               return MimeUtility.decode(
>                          getContentStream(), getEncoding());
>           }

>                     .... <other DataSource methods>
>       }

Specified by:
  `getDataHandler` in interface `Part`
Returns:
  DataHandler for the content
Throws:
  `MessagingException` - for failures

### getContent

public Object getContent() throws IOException, MessagingException
Return the content as a Java object. The type of this object is dependent on the content itself. For example, the native format of a "text/plain" content is usually a String object. The native format for a "multipart" message is always a Multipart subclass. For content types that are unknown to the DataHandler system, an input stream is returned as the content.

This implementation obtains the content from the DataHandler, that is, it invokes `getDataHandler().getContent()`. If the content is a Multipart or Message object and was created by parsing a stream, the object is cached and returned in subsequent calls so that modifications to the content will not be lost.

Specified by:
  `getContent` in interface `Part`
Returns:
  Object
Throws:
  `IOException` - this is typically thrown by the DataHandler. Refer to the documentation for javax.activation.DataHandler for more details.
  `MessagingException` - for other failures
See Also:
  - `Part`
  - `DataHandler.getContent()`

### setDataHandler

public void setDataHandler(DataHandler dh) throws MessagingException
This method provides the mechanism to set this part's content. The given DataHandler object should wrap the actual content.

Specified by:
  `setDataHandler` in interface `Part`
Parameters:
  `dh` - The DataHandler for the content.
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### setContent

public void setContent(Object o, String type) throws MessagingException
A convenience method for setting this Message's content.

The content is wrapped in a DataHandler object. Note that a DataContentHandler class for the specified type should be available to the JavaMail implementation for this to work right. i.e., to do `setContent(foobar, "application/x-foobar")`, a DataContentHandler for "application/x-foobar" should be installed. Refer to the Java Activation Framework for more information.

Specified by:
  `setContent` in interface `Part`
Parameters:
  `o` - the content object
  `type` - Mime type of the object
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### setText

public void setText(String text) throws MessagingException
Convenience method that sets the given String as this part's content, with a MIME type of "text/plain". If the string contains non US-ASCII characters. it will be encoded using the platform's default charset. The charset is also used to set the "charset" parameter.

Note that there may be a performance penalty if `text` is large, since this method may have to scan all the characters to determine what charset to use.

If the charset is already known, use the `setText` method that takes the charset parameter.

Specified by:
  `setText` in interface `MimePart`
Specified by:
  `setText` in interface `Part`
Parameters:
  `text` - the text content to set
Throws:
  `MessagingException` - if an error occurs
See Also:
  - `setText(String text, String charset)`

### setText

public void setText(String text, String charset) throws MessagingException
Convenience method that sets the given String as this part's content, with a MIME type of "text/plain" and the specified charset. The given Unicode string will be charset-encoded using the specified charset. The charset is also used to set the "charset" parameter.

Specified by:
  `setText` in interface `MimePart`
Parameters:
  `text` - the text content to set
  `charset` - the charset to use for the text
Throws:
  `MessagingException` - if an error occurs

### setText

public void setText(String text, String charset, String subtype) throws MessagingException
Convenience method that sets the given String as this part's content, with a primary MIME type of "text" and the specified MIME subtype. The given Unicode string will be charset-encoded using the specified charset. The charset is also used to set the "charset" parameter.

Specified by:
  `setText` in interface `MimePart`
Parameters:
  `text` - the text content to set
  `charset` - the charset to use for the text
  `subtype` - the MIME subtype to use (e.g., "html")
Throws:
  `MessagingException` - if an error occurs
Since:
  JavaMail 1.4

### setContent

public void setContent(Multipart mp) throws MessagingException
This method sets the Message's content to a Multipart object.

Specified by:
  `setContent` in interface `Part`
Parameters:
  `mp` - The multipart object that is the Message's content
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification of existing values
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### reply

public Message reply(boolean replyToAll) throws MessagingException
Get a new Message suitable for a reply to this message. The new Message will have its attributes and headers set up appropriately. Note that this new message object will be empty, i.e., it will not have a "content". These will have to be suitably filled in by the client.

If `replyToAll` is set, the new Message will be addressed to all recipients of this message. Otherwise, the reply will be addressed to only the sender of this message (using the value of the `getReplyTo` method).

The "Subject" field is filled in with the original subject prefixed with "Re:" (unless it already starts with "Re:"). The "In-Reply-To" header is set in the new message if this message has a "Message-Id" header. The `ANSWERED` flag is set in this message. The current implementation also sets the "References" header in the new message to include the contents of the "References" header (or, if missing, the "In-Reply-To" header) in this message, plus the contents of the "Message-Id" header of this message, as described in RFC 2822.

Specified by:
  `reply` in class `Message`
Parameters:
  `replyToAll` - reply should be sent to all recipients of this message
Returns:
  the reply Message
Throws:
  `MessagingException` - for failures

### reply

public Message reply(boolean replyToAll, boolean setAnswered) throws MessagingException
Get a new Message suitable for a reply to this message. The new Message will have its attributes and headers set up appropriately. Note that this new message object will be empty, i.e., it will not have a "content". These will have to be suitably filled in by the client.

If `replyToAll` is set, the new Message will be addressed to all recipients of this message. Otherwise, the reply will be addressed to only the sender of this message (using the value of the `getReplyTo` method).

If `setAnswered` is set, the `ANSWERED` flag is set in this message.

The "Subject" field is filled in with the original subject prefixed with "Re:" (unless it already starts with "Re:"). The "In-Reply-To" header is set in the new message if this message has a "Message-Id" header. The current implementation also sets the "References" header in the new message to include the contents of the "References" header (or, if missing, the "In-Reply-To" header) in this message, plus the contents of the "Message-Id" header of this message, as described in RFC 2822.

Parameters:
  `replyToAll` - reply should be sent to all recipients of this message
  `setAnswered` - set the ANSWERED flag in this message?
Returns:
  the reply Message
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.5

### writeTo

public void writeTo(OutputStream os) throws IOException, MessagingException
Output the message as an RFC 822 format stream.

Note that, depending on how the messag was constructed, it may use a variety of line termination conventions. Generally the output should be sent through an appropriate FilterOutputStream that converts the line terminators to the desired form, either CRLF for MIME compatibility and for use in Internet protocols, or the local platform's line terminator for storage in a local text file.

This implementation calls the `writeTo(OutputStream, String[])` method with a null ignore list.

Specified by:
  `writeTo` in interface `Part`
Parameters:
  `os` - the stream to write to
Throws:
  `IOException` - if an error occurs writing to the stream or if an error is generated by the javax.activation layer.
  `MessagingException` - for other failures
See Also:
  - `DataHandler.writeTo(java.io.OutputStream)`

### writeTo

public void writeTo(OutputStream os, String[] ignoreList) throws IOException, MessagingException
Output the message as an RFC 822 format stream, without specified headers. If the `saved` flag is not set, the `saveChanges` method is called. If the `modified` flag is not set and the `content` array is not null, the `content` array is written directly, after writing the appropriate message headers.

Parameters:
  `os` - the stream to write to
  `ignoreList` - the headers to not include in the output
Throws:
  `IOException` - if an error occurs writing to the stream or if an error is generated by the javax.activation layer.
  `MessagingException` - for other failures
See Also:
  - `DataHandler.writeTo(java.io.OutputStream)`

### getHeader

public String[] getHeader(String name) throws MessagingException
Get all the headers for this header_name. Note that certain headers may be encoded as per RFC 2047 if they contain non US-ASCII characters and these should be decoded.

This implementation obtains the headers from the `headers` InternetHeaders object.

Specified by:
  `getHeader` in interface `Part`
Parameters:
  `name` - name of header
Returns:
  array of headers
Throws:
  `MessagingException` - for failures
See Also:
  - `MimeUtility`

### getHeader

public String getHeader(String name, String delimiter) throws MessagingException
Get all the headers for this header name, returned as a single String, with headers separated by the delimiter. If the delimiter is `null`, only the first header is returned.

Specified by:
  `getHeader` in interface `MimePart`
Parameters:
  `name` - the name of this header
  `delimiter` - separator between values
Returns:
  the value fields for all headers with this name
Throws:
  `MessagingException` - for failures

### setHeader

public void setHeader(String name, String value) throws MessagingException
Set the value for this header_name. Replaces all existing header values with this new value. Note that RFC 822 headers must contain only US-ASCII characters, so a header that contains non US-ASCII characters must have been encoded by the caller as per the rules of RFC 2047.

Specified by:
  `setHeader` in interface `Part`
Parameters:
  `name` - header name
  `value` - header value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
See Also:
  - `MimeUtility`

### addHeader

public void addHeader(String name, String value) throws MessagingException
Add this value to the existing values for this header_name. Note that RFC 822 headers must contain only US-ASCII characters, so a header that contains non US-ASCII characters must have been encoded as per the rules of RFC 2047.

Specified by:
  `addHeader` in interface `Part`
Parameters:
  `name` - header name
  `value` - header value
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
See Also:
  - `MimeUtility`

### removeHeader

public void removeHeader(String name) throws MessagingException
Remove all headers with this name.

Specified by:
  `removeHeader` in interface `Part`
Parameters:
  `name` - the name of this header
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getAllHeaders

public Enumeration<Header> getAllHeaders() throws MessagingException
Return all the headers from this Message as an enumeration of Header objects.

Note that certain headers may be encoded as per RFC 2047 if they contain non US-ASCII characters and these should be decoded.

This implementation obtains the headers from the `headers` InternetHeaders object.

Specified by:
  `getAllHeaders` in interface `Part`
Returns:
  array of header objects
Throws:
  `MessagingException` - for failures
See Also:
  - `MimeUtility`

### getMatchingHeaders

public Enumeration<Header> getMatchingHeaders(String[] names) throws MessagingException
Return matching headers from this Message as an Enumeration of Header objects. This implementation obtains the headers from the `headers` InternetHeaders object.

Specified by:
  `getMatchingHeaders` in interface `Part`
Parameters:
  `names` - the headers to match
Returns:
  enumeration of Header objects
Throws:
  `MessagingException` - for failures

### getNonMatchingHeaders

public Enumeration<Header> getNonMatchingHeaders(String[] names) throws MessagingException
Return non-matching headers from this Message as an Enumeration of Header objects. This implementation obtains the header from the `headers` InternetHeaders object.

Specified by:
  `getNonMatchingHeaders` in interface `Part`
Parameters:
  `names` - the headers to not match
Returns:
  enumeration of Header objects
Throws:
  `MessagingException` - for failures

### addHeaderLine

public void addHeaderLine(String line) throws MessagingException
Add a raw RFC 822 header-line.

Specified by:
  `addHeaderLine` in interface `MimePart`
Parameters:
  `line` - the line to add
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### getAllHeaderLines

public Enumeration<String> getAllHeaderLines() throws MessagingException
Get all header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header-line, containing both the "name" and "value" field.

Specified by:
  `getAllHeaderLines` in interface `MimePart`
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures

### getMatchingHeaderLines

public Enumeration<String> getMatchingHeaderLines(String[] names) throws MessagingException
Get matching header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header-line, containing both the "name" and "value" field.

Specified by:
  `getMatchingHeaderLines` in interface `MimePart`
Parameters:
  `names` - the headers to return
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures

### getNonMatchingHeaderLines

public Enumeration<String> getNonMatchingHeaderLines(String[] names) throws MessagingException
Get non-matching header lines as an Enumeration of Strings. A Header line is a raw RFC 822 header-line, containing both the "name" and "value" field.

Specified by:
  `getNonMatchingHeaderLines` in interface `MimePart`
Parameters:
  `names` - the headers to not return
Returns:
  an Enumeration of Strings
Throws:
  `MessagingException` - for failures

### getFlags

public Flags getFlags() throws MessagingException
Return a `Flags` object containing the flags for this message.

Note that a clone of the internal Flags object is returned, so modifying the returned Flags object will not affect the flags of this message.

Specified by:
  `getFlags` in class `Message`
Returns:
  Flags object containing the flags for this message
Throws:
  `MessagingException` - for failures
See Also:
  - `Flags`

### isSet

public boolean isSet(Flags.Flag flag) throws MessagingException
Check whether the flag specified in the `flag` argument is set in this message.

This implementation checks this message's internal `flags` object.

Overrides:
  `isSet` in class `Message`
Parameters:
  `flag` - the flag
Returns:
  value of the specified flag for this message
Throws:
  `MessagingException` - for failures
See Also:
  - `Flags.Flag`
  - `Flags.Flag.ANSWERED`
  - `Flags.Flag.DELETED`
  - `Flags.Flag.DRAFT`
  - `Flags.Flag.FLAGGED`
  - `Flags.Flag.RECENT`
  - `Flags.Flag.SEEN`

### setFlags

public void setFlags(Flags flag, boolean set) throws MessagingException
Set the flags for this message.

This implementation modifies the `flags` field.

Specified by:
  `setFlags` in class `Message`
Parameters:
  `flag` - Flags object containing the flags to be set
  `set` - the value to be set
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures
See Also:
  - `MessageChangedEvent`

### saveChanges

public void saveChanges() throws MessagingException
Updates the appropriate header fields of this message to be consistent with the message's contents. If this message is contained in a Folder, any changes made to this message are committed to the containing folder.

If any part of a message's headers or contents are changed, `saveChanges` must be called to ensure that those changes are permanent. Otherwise, any such modifications may or may not be saved, depending on the folder implementation.

Messages obtained from folders opened READ_ONLY should not be modified and saveChanges should not be called on such messages.

This method sets the `modified` flag to true, the `save` flag to true, and then calls the `updateHeaders` method.

Specified by:
  `saveChanges` in class `Message`
Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### updateMessageID

protected void updateMessageID() throws MessagingException
Update the Message-ID header. This method is called by the `updateHeaders` and allows a subclass to override only the algorithm for choosing a Message-ID.

Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.4

### updateHeaders

protected void updateHeaders() throws MessagingException
Called by the `saveChanges` method to actually update the MIME headers. The implementation here sets the `Content-Transfer-Encoding` header (if needed and not already set), the `Date` header (if not already set), the `MIME-Version` header and the `Message-ID` header. Also, if the content of this message is a `MimeMultipart`, its `updateHeaders` method is called.

If the `cachedContent` field is not null (that is, it references a Multipart or Message object), then that object is used to set a new DataHandler, any stream data used to create this object is discarded, and the `cachedContent` field is cleared.

Throws:
  `IllegalWriteException` - if the underlying implementation does not support modification
  `IllegalStateException` - if this message is obtained from a READ_ONLY folder.
  `MessagingException` - for other failures

### createInternetHeaders

protected InternetHeaders createInternetHeaders(InputStream is) throws MessagingException
Create and return an InternetHeaders object that loads the headers from the given InputStream. Subclasses can override this method to return a subclass of InternetHeaders, if necessary. This implementation simply constructs and returns an InternetHeaders object.

Parameters:
  `is` - the InputStream to read the headers from
Returns:
  an InternetHeaders object
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.2

### createMimeMessage

protected MimeMessage createMimeMessage(Session session) throws MessagingException
Create and return a MimeMessage object. The reply method uses this method to create the MimeMessage object that it will return. Subclasses can override this method to return a subclass of MimeMessage. This implementation simply constructs and returns a MimeMessage object using the supplied Session.

Parameters:
  `session` - the Session to use for the new message
Returns:
  the new MimeMessage object
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.4